
//**************************************************************************/
// Copyright (c) 1998-2007 Autodesk, Inc.
// All rights reserved.
// 
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information written by Autodesk, Inc., and are
// protected by Federal copyright law. They may not be disclosed to third
// parties or copied or duplicated in any form, in whole or in part, without
// the prior written consent of Autodesk, Inc.
//**************************************************************************/
// DESCRIPTION: Appwizard generated plugin
// AUTHOR: Felix Joleanes
//***************************************************************************/

#include "AnimPivot.h"

static AnimPivotClassDesc AnimPivotDesc;
ClassDesc2* GetAnimPivotDesc() { return &AnimPivotDesc; }

static AnimPivotClassAccessor AnimPivotAccessor;
static AnimPivotClassValidator AnimPivotValidator;

enum { 
	AnimPivot_params,
	stepKeys_params,
};
enum {
	pb_target,
	pb_transPivot,
	pb_stepKeysV,
	pb_showPivot,
};
enum
{
	pb_stepKeys,
};

static ParamBlockDesc2 AnimPivot_param_blk ( AnimPivot_params, _T("params"),  0, &AnimPivotDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
	// params
	pb_target,		_T("Target"),		TYPE_INODE,	0,	IDS_TARGET,
		p_ui,		TYPE_PICKNODEBUTTON,		IDC_BUTTON_TARGET,
		p_accessor,	&AnimPivotAccessor,
		p_validator,&AnimPivotValidator,
		end,
	pb_transPivot,	_T("TranslatePivot"),	TYPE_BOOL,	0,	IDS_TRANSPIVOT,
		p_default,	FALSE,
		p_ui,		TYPE_SINGLECHEKBOX,		IDC_CHECK_TRANSPIVOT,
		end,
	pb_stepKeysV,	_T(""),	TYPE_BOOL,	P_TRANSIENT,	IDS_STEPKEYS,
		p_ui,		TYPE_SINGLECHEKBOX,		IDC_CHECK_STEPKEYS,
		p_accessor,	&AnimPivotAccessor,
		end,
	pb_showPivot,	_T("ShowPivot"),	TYPE_BOOL,	0,	IDS_SHOWPIVOT,
		p_default,	TRUE,
		end,
	end
);
static ParamBlockDesc2 stepKeys_param_blk ( stepKeys_params, _T("step params"),  0, &AnimPivotDesc, 
	P_AUTO_CONSTRUCT, STEP_PBLOCK_REF, 
	// params
	pb_stepKeys,	_T("StepKeys"),	TYPE_BOOL,	0,	IDS_STEPKEYS,
		p_default,	FALSE,
		p_ui,		TYPE_SINGLECHEKBOX,		IDC_CHECK_STEPKEYS,
		end,
	end
);

//interface desc to publish functions
static FPInterfaceDesc animPivot_mixininterface(ANIMPIVOT_INTERFACE, 
   _T("offset"), 0, &AnimPivotDesc, 0, 
   AnimPivotInterface::fnGetRelativePos, _T("GetRelativePos"), 0, TYPE_POINT3_BV, 0, 0, 
   AnimPivotInterface::fnSetRelativePos, _T("SetRelativePos"), 0, TYPE_VOID, 0, 1, 
     _T("relative position"), 0, TYPE_POINT3, 
   end 
); 

FPInterfaceDesc* AnimPivotInterface::GetDesc() 
{ 
   return &animPivot_mixininterface; 
}

INT_PTR AnimPivotDlgProc::DlgProc (TimeValue t, IParamMap2 *map, HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	ICustButton *iBut;
	BOOL showPivot,stepKeys;
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			animpivot->pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
			iBut = GetICustButton(GetDlgItem(animpivot->hwnd,IDC_BUTTON_PIVOT));
			iBut->SetType(CBT_CHECK);
			iBut->SetHighlightColor(GREEN_WASH);
			iBut->SetCheck(showPivot);
			ReleaseICustButton(iBut);
			iBut = GetICustButton(GetDlgItem(animpivot->hwnd,IDC_BUTTON_TRANSFORM));
			iBut->SetType(CBT_CHECK);
			iBut->SetHighlightColor(GREEN_WASH);
			iBut->SetCheck(!showPivot);
			ReleaseICustButton(iBut);
			animpivot->stepPblock->GetValue(pb_stepKeys,0,stepKeys,FOREVER);
			animpivot->pblock->SetValue(pb_stepKeysV,0,stepKeys);
		}
		break;
	case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDC_BUTTON_REMOVE:
				{
					BOOL notHolding=!theHold.Holding();
					if (notHolding)
						theHold.Begin();
					INode *nullNode=NULL;
					animpivot->pblock->SetValue(pb_target,0,nullNode);
					if (notHolding)
						theHold.Accept(_T("Remove Target"));
				}
				break;
			case IDC_BUTTON_PIVOT:
				animpivot->pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
				if (!showPivot)
				{
					animpivot->pblock->SetValue(pb_showPivot,0,TRUE);
					iBut = GetICustButton(GetDlgItem(animpivot->hwnd,IDC_BUTTON_TRANSFORM));
					iBut->SetCheck(FALSE);
					ReleaseICustButton(iBut);
					animpivot->TMCtrl->EndEditParams(animpivot->ip,END_EDIT_REMOVEUI,NULL);
					animpivot->pivotCtrl->GetController()->BeginEditParams(animpivot->ip,BEGIN_EDIT_MOTION,NULL);
				}
				iBut = GetICustButton(GetDlgItem(animpivot->hwnd,IDC_BUTTON_PIVOT));
				iBut->SetCheck(TRUE);
				ReleaseICustButton(iBut);
				break;
			case IDC_BUTTON_TRANSFORM:
				animpivot->pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
				if (showPivot)
				{
					animpivot->pblock->SetValue(pb_showPivot,0,FALSE);
					iBut = GetICustButton(GetDlgItem(animpivot->hwnd,IDC_BUTTON_PIVOT));
					iBut->SetCheck(FALSE);
					ReleaseICustButton(iBut);
					animpivot->pivotCtrl->EndEditParams(animpivot->ip,END_EDIT_REMOVEUI,NULL);
					animpivot->TMCtrl->BeginEditParams(animpivot->ip,BEGIN_EDIT_MOTION,NULL);
				}
				iBut = GetICustButton(GetDlgItem(animpivot->hwnd,IDC_BUTTON_TRANSFORM));
				iBut->SetCheck(TRUE);
				ReleaseICustButton(iBut);
				break;
			case IDC_BUTTON_ABOUT:
				DialogBox(
						hInstance,
						MAKEINTRESOURCE(IDD_DIALOG),
						hWnd,
						AboutDlgProc);
				break;
			}
		break;
	}
	return FALSE;
}


void AnimPivotClassAccessor::Set(PB2Value& v,ReferenceMaker* owner,ParamID id,int tabIndex,TimeValue t)
{
	AnimPivot *theAnimPivot=(AnimPivot *)owner;
	switch (id)
	{
		case pb_target:
		{
			INode *targetNode=(INode *)v.r;
			theAnimPivot->RemoveTarget();
			if (targetNode)
			{
				Point3 newOffset;
				if (theAnimPivot->targetSetup)
					newOffset=(theAnimPivot->value*theAnimPivot->parentTM*Inverse(targetNode->GetNodeTM(t))).GetTrans();
				Control *theNewTMCtrl=targetNode->GetTMController();
				BOOL isIKFK=theNewTMCtrl->ClassID()==FKCtrl_CLASS_ID || theNewTMCtrl->ClassID()==IKCtrl_CLASS_ID;
				if (isIKFK)
					theNewTMCtrl=(Control*)theNewTMCtrl->GetReference(LOCALCTRL_REF);
				if (theNewTMCtrl->ClassID()!=Class_ID(PRS_CONTROL_CLASS_ID,0))
				{
					Matrix3 TMVal=Matrix3(1);
					theNewTMCtrl->GetValue(GetCOREInterface()->GetTime(),&TMVal,FOREVER,CTRL_RELATIVE);
					theNewTMCtrl=(Control *)CreateInstance(CTRL_MATRIX3_CLASS_ID, Class_ID(PRS_CONTROL_CLASS_ID,0));
					SetXFormPacket mat;
					mat.command=XFORM_SET;
					mat.tmAxis=TMVal;
					mat.tmParent=Matrix3(1);		
					theNewTMCtrl->SetValue(0,&mat,1,CTRL_ABSOLUTE);
				}
				theAnimPivot->TMCtrl->SetController(theNewTMCtrl);
				AnimPivotTarget *newTargetCtrl=new AnimPivotTarget(theAnimPivot->pivotCtrl,theAnimPivot->TMCtrl,theAnimPivot->stepPblock,theAnimPivot->offsetCtrl);
				if (isIKFK)
					targetNode->GetTMController()->ReplaceReference(LOCALCTRL_REF,newTargetCtrl);
				else
					targetNode->SetTMController(newTargetCtrl);
				if (theAnimPivot->targetSetup)
					theAnimPivot->InitOffset(newOffset);
			}
			else
			{
				ICustButton *iBut = GetICustButton(GetDlgItem(theAnimPivot->hwnd,IDC_BUTTON_TARGET));
				if (iBut)
					iBut->SetText(_T("None"));
				ReleaseICustButton(iBut);
				theAnimPivot->ResetTM();
			}
			theAnimPivot->TMCtrl->NotifyDependents(FOREVER,0,REFMSG_CHANGE);
		}
		break;
		case pb_stepKeysV:
		{
			theAnimPivot->stepPblock->SetValue(pb_stepKeys,0,v.i);
		}
		break;
	}
}
BOOL AnimPivotClassValidator::Validate(PB2Value& v,ReferenceMaker* owner,ParamID id,int tabIndex)
{
	
	switch (id)
	{
		case pb_target:
		{
			AnimPivot *theAnimPivot=(AnimPivot *)owner;
			INode *targetNode=(INode *)v.r;
			targetNode->BeginDependencyTest();
			theAnimPivot->NotifyDependents(FOREVER,0,REFMSG_TEST_DEPENDENCY);
			return (!targetNode->EndDependencyTest() && (theAnimPivot->pblock->GetINode(pb_target)!=targetNode));
		}
	}
	return FALSE;
}
int  AnimPivotPostPatchProc::Proc (RemapDir &remap)
{
	AnimPivot *clonedCtrl=(AnimPivot*)remap.FindMapping(ctrl);
	INode *clonedTarget=(INode*)remap.FindMapping(ctrl->pblock->GetINode(pb_target));
	if (clonedTarget)
	{
		clonedCtrl->targetSetup=FALSE;
		clonedCtrl->pblock->SetValue(pb_target,0,clonedTarget);
		clonedCtrl->targetSetup=TRUE;
	}
	return 0;
}
AnimPivot::AnimPivot(BOOL loading)
{
	pblock = NULL;
	stepPblock=NULL;
	pivotCtrl=NULL;
	prevPivotCtrl=NULL;
	offsetCtrl=NULL;
	TMCtrl=NULL;
	value=Matrix3(1);
	needUpdate=TRUE;
	notIgnoreChange=TRUE;
	canUpdateOffset=0;
	ivalid=FOREVER;
	prevT=GetCOREInterface()->GetTime();
	targetSetup=TRUE;
	parentTM=Matrix3(1);
	if (!loading)
	{
		// make the paramblock
		AnimPivotDesc.MakeAutoParamBlocks(this);
		//pblock->CallSets();
		ReplaceReference(PIVOT_REF,new ControlContainer((Control *)CreateInstance(CTRL_POSITION_CLASS_ID, Class_ID(HYBRIDINTERP_POSITION_CLASS_ID,0)),GetString(IDS_PIVOT),FALSE));
		ReplaceReference(PREVPIVOT_REF,(Control *)CreateInstance(CTRL_POSITION_CLASS_ID, Class_ID(HYBRIDINTERP_POSITION_CLASS_ID,0)));
		ReplaceReference(OFFSET_REF,new ControlContainer((Control *)CreateInstance(CTRL_POSITION_CLASS_ID, Class_ID(HYBRIDINTERP_POSITION_CLASS_ID,0)),GetString(IDS_OFFSET),FALSE));
		ReplaceReference(TM_REF,new ControlContainer((Control *)CreateInstance(CTRL_MATRIX3_CLASS_ID, Class_ID(PRS_CONTROL_CLASS_ID,0)),GetString(IDS_TM),FALSE));
	}
}


Animatable* AnimPivot::SubAnim(int i)
{
	switch(i)
	{
	case PIVOT_REF:
		return pivotCtrl;
		break;
	case TM_REF:
		return TMCtrl;
		break;
	default:
		return NULL;
		break;
	}	
}
TSTR AnimPivot::SubAnimName(int i)
{
	switch(i)
	{
	case PIVOT_REF:
		return GetString(IDS_PIVOT);
		break;
	case TM_REF:
		return GetString(IDS_TM);
		break;
	default:
		return _T("");
		break;
	}
}
void AnimPivot::MouseCycleStarted(TimeValue t)
{
	canUpdateOffset=1;
}
void AnimPivot::MouseCycleCompleted(TimeValue t)
{
	//the offset should not be updated in set key mode, to avoid wrong offset transformations
	//unless a new key is created
	canUpdateOffset=0;
	if (pivotHasChanged && !GetSetKeyMode()) 
		UpdateOffset();
	needUpdate=TRUE;
}
void AnimPivot::RevertSetKeyBuffer()
{
	TimeValue t=GetCOREInterface()->GetTime();
	offsetCtrl->GetController()->GetValue(t,&SKMOffset,FOREVER,CTRL_ABSOLUTE);
	pivotCtrl->GetController()->GetValue(t,&SKMPrevPivot,FOREVER,CTRL_ABSOLUTE);
	needUpdate=TRUE;
}
void AnimPivot::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	if (flags & BEGIN_EDIT_MOTION)
	{
		this->ip=ip;
		AnimPivotDesc.BeginEditParams(ip,this,flags,prev);
		hwnd=pblock->GetMap()->GetHWnd();
		BOOL showPivot;
		pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
		if (showPivot)
			pivotCtrl->BeginEditParams(ip,flags,prev);
		else
			TMCtrl->BeginEditParams(ip,flags,prev);
		AnimPivot_param_blk.SetUserDlgProc(AnimPivot_params,new AnimPivotDlgProc(this));
	}
}
void AnimPivot::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	if (flags & END_EDIT_REMOVEUI)
	{
		AnimPivotDesc.EndEditParams(ip,this,flags,next);
		BOOL showPivot;
		pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
		if (showPivot)
			pivotCtrl->EndEditParams(ip,flags,next);
		else
			TMCtrl->EndEditParams(ip,flags,next);
	}
}


RefTargetHandle AnimPivot::GetReference(int i)
{ 
	switch (i)
	{
	case PIVOT_REF:
		return pivotCtrl;
		break;
	case TM_REF:
		return TMCtrl;
		break;
	case PBLOCK_REF:
		return pblock;
		break;
	case STEP_PBLOCK_REF:
		return stepPblock;
		break;
	case OFFSET_REF:
		return offsetCtrl;
		break;
	case PREVPIVOT_REF:
		return prevPivotCtrl;
		break;
	}
	return NULL;
}
void AnimPivot::SetReference(int i, RefTargetHandle rtarg) 
{ 
	switch (i)
	{
	case PIVOT_REF:
		pivotCtrl=(ControlContainer *)rtarg;
		if (pivotCtrl)
		{
			pivotKeys=GetKeyControlInterface(pivotCtrl->GetController());
			pivotCtrl->GetController()->GetValue(GetCOREInterface()->GetTime(),&SKMPrevPivot,FOREVER,CTRL_ABSOLUTE);
		}
		break;
	case TM_REF:
		TMCtrl=(ControlContainer*)rtarg;
		break;
	case PBLOCK_REF:
		pblock=(IParamBlock2*)rtarg;
		break;
	case STEP_PBLOCK_REF:
		stepPblock=(IParamBlock2*)rtarg;
		break;
	case OFFSET_REF:
		offsetCtrl=(ControlContainer*)rtarg;
		if(offsetCtrl)
		{
			offsetKeys=GetKeyControlInterface(offsetCtrl->GetController());
			offsetCtrl->GetController()->GetValue(GetCOREInterface()->GetTime(),&SKMOffset,FOREVER,CTRL_ABSOLUTE);
		}
		break;
	case PREVPIVOT_REF:
		prevPivotCtrl=(Control*)rtarg;
		if(prevPivotCtrl)
			prevPivotKeys=GetKeyControlInterface(prevPivotCtrl);
		break;

	}
}

#if IS_SUPMAX2015
RefResult AnimPivot::NotifyRefChanged(const Interval& changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message, BOOL propagate)
#else
RefResult AnimPivot::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message)
#endif
{ 
switch (message) { 
	 case REFMSG_CHANGE: 
		 //if the tm controller has changed, the controller must update
		 if (hTarget==TMCtrl)
		 {
			 if (pivotHasChanged)
				 UpdateOffset();
			 needUpdate=TRUE;
		 }
		 //if the pivot controller has changed, the controller must stay still
		 if (hTarget==pivotCtrl)
		 {
			switch(canUpdateOffset)
			{
			case 0:
				UpdateOffset();
				break;
			case 1:
				UpdateOffset();
				canUpdateOffset=2;
				break;
			case 2:
				pivotHasChanged=TRUE;
				return REF_STOP;
				break;
			}
		 }
		 //if the target node has changed, the controller needs to update
		 //only if the partID is PART_TM, and if the change doesn't need to be
		 //ignored
		 if (hTarget==pblock)
		 {
			 ParamID changing_param = pblock->LastNotifyParamID(); 
			 if (changing_param==pb_target)
			 {
				 if (partID==PART_TM)
				 {
					 if(notIgnoreChange)
						 needUpdate=TRUE;
					 else
					 {
						 notIgnoreChange=TRUE;
						 return REF_STOP;
					 }
				 }
				 else
					 return REF_STOP;
			 }
		 }
		 if (hTarget==offsetCtrl)
			 return REF_STOP;
	 break; 
	 //if the target node has sent this message, this controller
	 //must ignore the next change message from the target node
	 case REFMSG_IGNORE_CHANGE:
		 if (hTarget==pblock)
			 notIgnoreChange=FALSE;
		 break;
	 case REFMSG_PIVOT_MOUSE_CYCLE_STARTED:
		 NotifyDependents(FOREVER,0,REFMSG_MOUSE_CYCLE_STARTED);
		 break;
	 case REFMSG_PIVOT_MOUSE_CYCLE_COMPLETED:
		 NotifyDependents(FOREVER,0,REFMSG_MOUSE_CYCLE_COMPLETED);
		 break;
	 case REFMSG_MOUSE_CYCLE_STARTED:
		 if (hTarget==pblock)
			 return REF_STOP;
		 break;
	 case REFMSG_MOUSE_CYCLE_COMPLETED:
		 if (hTarget==pblock)
			 return REF_STOP;
		 break;
	 case REFMSG_CONTROLREF_CHANGE:
		 if (hTarget==pblock)
			 CheckTarget();
		 break;
#if IS_SUPMAX2015
	 case REFMSG_CONTAINER_ELEMENT_NULLED:
#else
	 case REFMSG_TAB_ELEMENT_NULLED:
#endif
		 if (hTarget==pblock)
			 ResetTM();
		 break;
	 case REFMSG_OBJECT_CACHE_DUMPED:
		 return REF_STOP;
		break; 
 } 
return REF_SUCCEED; 
}



void AnimPivot::Copy(Control *from)
{
	if (from->ClassID()==Class_ID(PRS_CONTROL_CLASS_ID,0))
		TMCtrl->SetController((Control*)from);	
	else
	{
		Matrix3 TMVal=Matrix3(1);
		from->GetValue(GetCOREInterface()->GetTime(),&TMVal,FOREVER,CTRL_RELATIVE);
		from=(Control *)CreateInstance(CTRL_MATRIX3_CLASS_ID, Class_ID(PRS_CONTROL_CLASS_ID,0));
		SetXFormPacket mat;
		mat.command=XFORM_SET;
		mat.tmAxis=TMVal;
		mat.tmParent=Matrix3(1);		
		from->SetValue(0,&mat,1,CTRL_ABSOLUTE);
	}
	Update(GetCOREInterface()->GetTime());
	NotifyDependents(FOREVER,0,REFMSG_CHANGE);
	NotifyDependents(FOREVER,0,REFMSG_SUBANIM_STRUCTURE_CHANGED);
}
RefTargetHandle AnimPivot::Clone(RemapDir& remap)
{
	AnimPivot *p = new AnimPivot(FALSE);
	/*INode *target=pblock->GetINode(pb_target);
	INode *clonedTarget=(INode*)remap.CloneRef(target);
	if (!clonedTarget)
		mputs(_T("no hay clonedTarget\n"));
	if (clonedTarget!=target)
		mputs(_T("son iguales\n"));
	else
		mputs(_T("son distintos\n"));*/
	
	p->ReplaceReference(PIVOT_REF,remap.CloneRef(pivotCtrl));
	p->ReplaceReference(TM_REF,remap.CloneRef(TMCtrl));
	p->ReplaceReference(STEP_PBLOCK_REF,remap.CloneRef(stepPblock));
	p->ReplaceReference(OFFSET_REF,remap.CloneRef(offsetCtrl));
	p->ReplaceReference(PREVPIVOT_REF,remap.CloneRef(prevPivotCtrl));

	BOOL value;
	pblock->GetValue(pb_transPivot,0,value,FOREVER);
	p->pblock->SetValue(pb_transPivot,0,value);
	pblock->GetValue(pb_stepKeysV,0,value,FOREVER);
	p->pblock->SetValue(pb_stepKeysV,0,value);
	pblock->GetValue(pb_showPivot,0,value,FOREVER);
	p->pblock->SetValue(pb_showPivot,0,value);

	remap.AddPostPatchProc(new AnimPivotPostPatchProc(this),TRUE);

	/*p->ResetTM();
	INode *target=pblock->GetINode(pb_target);
	INode *clonedTarget=(INode*)remap.CloneRef(target);
	if (clonedTarget!=target)
		p->pblock->SetValue(pb_target,0,clonedTarget);*/
	
	/*IParamBlock2	*clonedPblock=(IParamBlock2 *)remap.CloneRef(pblock);
	p->ReplaceReference(PBLOCK_REF,clonedPblock);
	INode *clonedTarget=clonedPblock->GetINode(pb_target);

	if (clonedTarget==pblock->GetINode(pb_target))
	{
		clonedTarget=NULL;
		clonedPblock->SetValue(pb_target,0,clonedTarget);
	}*/
	BaseClone(this, p, remap);
	return p;
}
void AnimPivot::GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method)
{
	if (t!=prevT)
	{
		offsetCtrl->GetController()->GetValue(t,&SKMOffset,FOREVER,CTRL_ABSOLUTE);
		pivotCtrl->GetController()->GetValue(t,&SKMPrevPivot,FOREVER,CTRL_ABSOLUTE);
	}
	if (needUpdate||(t!=prevT))
	{
		Update(t);
		prevT=t;
	}
	INode *target;
	target=pblock->GetINode(pb_target);
	if (target)
		*((Matrix3 *)val)=value;
	else
		*((Matrix3 *)val)=value*(*((Matrix3 *)val));
	valid &=ivalid;
}
void AnimPivot::SetValue(TimeValue t, void *val, int commit, GetSetMethod method)
{
	BOOL transPivot;
	SetXFormPacket *mat=(SetXFormPacket *)val;
	INode *targetNode=pblock->GetINode(pb_target);
	Point3 pivotVal;
	pblock->GetValue(pb_transPivot,0,transPivot,FOREVER);
	
	if (targetNode)
		mat->tmParent=targetNode->GetParentTM(t);
	if (transPivot && mat->command!=XFORM_SET)
	{
		if (mat->command==XFORM_MOVE)
		{
			mat->tmAxis.NoTrans();
			mat->tmParent.NoTrans();
			pivotVal=mat->p*mat->tmAxis*Inverse(mat->tmParent);
			pivotCtrl->GetController()->SetValue(t,&pivotVal,commit,method);
		}
		else
			TMCtrl->GetController()->SetValue(t,mat,commit,method);
	}
	else
	{
		offsetCtrl->GetController()->GetValue(t,&pivotVal,FOREVER,CTRL_ABSOLUTE);
		mat->tmAxis.PreTranslate(-pivotVal);
		pivotCtrl->GetController()->GetValue(t,&pivotVal,FOREVER,CTRL_ABSOLUTE);
		mat->tmParent.PreTranslate(pivotVal);
		TMCtrl->GetController()->SetValue(t,mat,commit,method);
	}
}
void AnimPivot::CommitValue(TimeValue t)
{
	pivotCtrl->GetController()->CommitValue(t);
	TMCtrl->GetController()->CommitValue(t);
}

void AnimPivot::RestoreValue(TimeValue t)
{
	pivotCtrl->GetController()->RestoreValue(t);
	TMCtrl->GetController()->RestoreValue(t);
}
Control* AnimPivot::GetPositionController()
{
	BOOL transPivot;
	pblock->GetValue(pb_transPivot,0,transPivot,FOREVER);
	
	if (TMCtrl->GetController()) 
	{
		if (transPivot)
			return pivotCtrl->GetController();
		else
			return TMCtrl->GetController()->GetPositionController(); 
	}
	else return NULL;
}
Control* AnimPivot::GetRotationController()
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->GetRotationController(); 
	else 
		return NULL;
}
Control* AnimPivot::GetScaleController()
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->GetScaleController(); 
	else 
		return NULL;
}
BOOL AnimPivot::SetPositionController(Control *c)
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->SetPositionController(c);
	else 
		return FALSE;
}
BOOL AnimPivot::SetRotationController(Control *c)
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->SetRotationController(c); 
	else 
		return FALSE;
}
BOOL AnimPivot::SetScaleController(Control *c)
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->SetScaleController(c);
	else
		return FALSE;
}
BOOL AnimPivot::ChangeParents  (TimeValue  t,const Matrix3 &oldP, const Matrix3 &newP, const Matrix3 &tm)
{
	if (!pblock->GetINode(pb_target) && TMCtrl->GetController())
	{
		SetXFormPacket mat;
		mat.tmParent=newP;
		mat.tmAxis=tm;
		mat.command=XFORM_SET;
		TMCtrl->GetController()->SetValue(t,&mat);
	}
	return TRUE;
}
void AnimPivot::CheckTarget()
{
	//if the target has changed its transform controller
	//this ctrl has to reinstance the TM, pivot and offset control containers
	//to do so, it needs to find the animPivotTarget in the subAnim hierarchy
	INode *targetNode;	targetNode=pblock->GetINode(pb_target);
	
	if (targetNode)
	{
		AnimPivotTarget *targetCtrl; 
		targetCtrl=(AnimPivotTarget*)FindAnimPivotTarget(targetNode->GetTMController());
		if (targetCtrl)
		{
			if (targetCtrl->TMCtrl!=TMCtrl)
			{
				ReplaceReference(TM_REF,targetCtrl->TMCtrl);
				ReplaceReference(PIVOT_REF,targetCtrl->pivotCtrl);
				ReplaceReference(OFFSET_REF,targetCtrl->offsetCtrl);
			}
		}
		else
		{
			INode *NullNode=NULL;
			pblock->SetValue(pb_target,0,NullNode);
		}
	}
}
ReferenceTarget* AnimPivot::FindAnimPivotTarget(ReferenceTarget* theTarget)
{
	if (theTarget)
	{
		if (theTarget->ClassID()==AnimPivotTarget_CLASS_ID)
			return theTarget;
		int nRefs=theTarget->NumRefs();
		for (int i=0; i<nRefs; i++)
		{
			ReferenceTarget *theNewTarget=FindAnimPivotTarget(theTarget->GetReference(i));
			if (theNewTarget)
				return theNewTarget;
		}
	}
	return NULL;
}
void AnimPivot::Update(TimeValue t)
{
	ivalid=FOREVER;
	INode *targetNode=pblock->GetINode(pb_target);
	if (targetNode)
	{
		value=GetTargetTM(t,ivalid);
	}
	else
	{
		value=Matrix3(1);
		pivotCtrl->GetController()->GetValue(t,&value,ivalid,CTRL_RELATIVE);
		TMCtrl->GetController()->GetValue(t,&value,ivalid,CTRL_RELATIVE);
	}
	
	Point3 offsetPos;
	if (GetSetKeyMode())
	{
		Point3 SKMPivot;
		pivotCtrl->GetController()->GetValue(t,&SKMPivot,ivalid,CTRL_ABSOLUTE);
		Matrix3 TMVal=Matrix3(1);
		TMCtrl->GetValue(t,&TMVal,ivalid,CTRL_RELATIVE);
		offsetPos=MakeOffset(TMVal,SKMPivot,SKMPrevPivot,SKMOffset);
	}
	else
	{
		//the offset should not be updated in set key mode, to avoid wrong offset transformations
		//unless a new key is created
		if (pivotHasChanged)
			UpdateOffset();
		offsetCtrl->GetController()->GetValue(t,&offsetPos,ivalid,CTRL_ABSOLUTE);
	}
		//Set Key Mode refresh
	SKMOffset=offsetPos;
	pivotCtrl->GetController()->GetValue(t,&SKMPrevPivot,ivalid,CTRL_ABSOLUTE);
	//value refresh
	value.PreTranslate(offsetPos);
	needUpdate=FALSE;

}
void AnimPivot::InitOffset(Point3 offset)
{
	IKeyControl *KeysInterface;
	Point3 zeroPos=Point3(0,0,0);
	//set the initial pivot controller value
	offsetCtrl->GetController()->SetValue(0,&offset,1,CTRL_ABSOLUTE);
	prevPivotCtrl->SetValue(0,&zeroPos,1,CTRL_ABSOLUTE);
	pivotCtrl->GetController()->SetValue(0,&zeroPos,1,CTRL_ABSOLUTE);
	//delete all the keyframes of pivot, prevPivot and offset controllers
	KeysInterface=GetKeyControlInterface(prevPivotCtrl);
	KeysInterface->SetNumKeys(0);
	KeysInterface=GetKeyControlInterface(offsetCtrl->GetController());
	KeysInterface->SetNumKeys(0);
	KeysInterface=GetKeyControlInterface(pivotCtrl->GetController());
	KeysInterface->SetNumKeys(0);
	pivotHasChanged=FALSE;
}
void AnimPivot::UpdateOffset()
{
	int numPivotKeys=pivotKeys->GetNumKeys();
	int numPrevPivotKeys=prevPivotKeys->GetNumKeys();	
	int k, newKey=-1;
	int auxCanUpdate=canUpdateOffset;
	canUpdateOffset=2;

	if (numPivotKeys==numPrevPivotKeys) //search for modified keys
	{
		if (numPivotKeys==0)
			MakeOffset();	 
		else
		{
			for (k=0;k<numPivotKeys;k++)
			{
				if (SwapOffset(k))
					k++;
				else if (!KeysEqual(k,k))
					MakeOffset(k);
			}
		}
	}
	else
	{
		TimeValue keyTime;
		if (numPivotKeys>numPrevPivotKeys) // search for new keys
		{
			BOOL onlyANewKey=(numPivotKeys-numPrevPivotKeys==1);
			for (k=0;(k<numPivotKeys && k<numPrevPivotKeys);k++)
			{
				if (!KeysEqual(k,k)) //Process new Key or modified key
				{
					keyTime=pivotCtrl->GetController()->GetKeyTime(k);
					if (prevPivotCtrl->GetKeyIndex(keyTime)==-1)
					{
						SetStepKey(k);//it set the step interpolacion for the new key, only if the step option is active
						
						offsetCtrl->GetController()->AddNewKey(keyTime,0);
						prevPivotCtrl->AddNewKey(keyTime,0);
						
						numPrevPivotKeys++;
						newKey=k;

						if (!CopyOffset(k))
						{
							SetStepKey(k);
							MakeOffset(k);
						}
					}
				}
			}
			for (;k<numPivotKeys;k++) //Process new Keys
			{
				keyTime=pivotCtrl->GetController()->GetKeyTime(k);
				if (prevPivotCtrl->GetKeyIndex(keyTime)==-1)
				{
					SetStepKey(k);//it set the step interpolacion for the new key, only if the step option is active
					offsetCtrl->GetController()->AddNewKey(keyTime,0);
					prevPivotCtrl->AddNewKey(keyTime,0);
					MakeOffset(k);
					newKey=k;
				}
			}
			//make the step offset for the new key (if there is only one new key)
			if (onlyANewKey && newKey>=0)
				SOOffsetKey(newKey);
		}
		else							//search for deleted keys
		{
			if (numPivotKeys)
			{
				for (k=0;(k<numPrevPivotKeys && k<numPivotKeys);)
				{
					if (!KeysEqual(k,k)) //Process deleted Key
					{
						offsetCtrl->GetController()->DeleteKeyByIndex(k);
						prevPivotCtrl->DeleteKeyByIndex(k);
						numPrevPivotKeys--;
					}
					else
						k++;
				}
				for (;k<numPrevPivotKeys;numPrevPivotKeys--) //Process deleted Keys
				{
					offsetCtrl->GetController()->DeleteKeyByIndex(k);
					prevPivotCtrl->DeleteKeyByIndex(k);
				}
			}
			else
			{
				//Get Offset Current Values in order to keep them after deleting all the keys
				Point3 prevPivotVal,offsetVal;
				TimeValue currentTime=GetCOREInterface()->GetTime();
				pivotCtrl->GetController()->GetValue(currentTime,&prevPivotVal,FOREVER,CTRL_ABSOLUTE);
				offsetCtrl->GetController()->GetValue(currentTime,&offsetVal,FOREVER,CTRL_ABSOLUTE);

				offsetCtrl->GetController()->DeleteKeys(TRACK_DOALL);
				prevPivotCtrl->DeleteKeys(TRACK_DOALL);

				//set the values
				prevPivotCtrl->SetValue(0,&prevPivotVal,1,CTRL_ABSOLUTE);
				offsetCtrl->GetController()->SetValue(0,&offsetVal,1,CTRL_ABSOLUTE);
			}
		}
	}
	canUpdateOffset=auxCanUpdate;
	pivotHasChanged=FALSE;
	
}
void AnimPivot::MakeOffset()
{
	//Get Values
	Point3 pivotVal,prevPivotVal,offsetVal;
	pivotCtrl->GetController()->GetValue(0,&pivotVal,FOREVER,CTRL_ABSOLUTE);
	prevPivotCtrl->GetValue(0,&prevPivotVal,FOREVER,CTRL_ABSOLUTE);
	offsetCtrl->GetController()->GetValue(0,&offsetVal,FOREVER,CTRL_ABSOLUTE);
	//modify values
	Matrix3 TMVal=Matrix3(1);
	TMCtrl->GetController()->GetValue(GetCOREInterface()->GetTime(),&TMVal,FOREVER,CTRL_RELATIVE);
	offsetVal=MakeOffset(TMVal,pivotVal,prevPivotVal,offsetVal);
	//set the values
	prevPivotCtrl->SetValue(0,&pivotVal,1,CTRL_ABSOLUTE);
	TMCtrl->GetController()->MouseCycleCompleted(GetCOREInterface()->GetTime());
	offsetCtrl->GetController()->SetValue(0,&offsetVal,1,CTRL_ABSOLUTE);
	TMCtrl->GetController()->MouseCycleStarted(GetCOREInterface()->GetTime());
	
}
void AnimPivot::MakeOffset(int keyIndex)
{
	IBezPoint3Key pivotKey,prevPivotKey,offsetKey;
	//Get Keys
	pivotKeys->GetKey(keyIndex,&pivotKey);

	//Make sure it's a valid key, no 1.#QNAN values, this has to be done to avoid bugs when loading keys
	if (!(_isnan(pivotKey.val.x) || _isnan(pivotKey.val.y) || _isnan(pivotKey.val.z)))
	{
		prevPivotKeys->GetKey(keyIndex,&prevPivotKey);
		offsetKeys->GetKey(keyIndex,&offsetKey);

		//modify the offset key
		Matrix3 TMVal=Matrix3(1);
		Point3 auxLength;
		TMCtrl->GetController()->GetValue(pivotKey.time,&TMVal,FOREVER,CTRL_RELATIVE);
		offsetKey.flags=pivotKey.flags;
		offsetKey.time=pivotKey.time;
		if (pivotKey.val!=prevPivotKey.val)
			offsetKey.val=MakeOffset(TMVal,pivotKey.val,prevPivotKey.val,offsetKey.val);
		//set the keys
		prevPivotKeys->SetKey(keyIndex,&pivotKey);
		offsetKeys->SetKey(keyIndex,&offsetKey);
	}
}
Point3 AnimPivot::MakeOffset(Matrix3 TMVal,Point3 pivotVal,Point3 prevPivotVal,Point3 offsetVal)
{
	Matrix3 pivotTM,prevPivotTM;
	pivotTM=Matrix3(1);
	prevPivotTM=Matrix3(1);
	pivotTM.SetTrans(pivotVal);
	prevPivotTM.SetTrans(prevPivotVal);
	/*
	This is the equation to find the new offset key value:
	newOff*TM*newPivot=prevOff*TM*prevPivot
	newOff=prevOff*TM*prevPivot*inverse(newPivot)*inverse(TM)
	Coded as follows:
	*/
	return (offsetVal*(TMVal*prevPivotTM*Inverse(TMVal*pivotTM)));
}
//this function is used to check if the keyframe has been copied, to ensure that the offset and prevpivot
//keys are copied as well
BOOL AnimPivot::CopyOffset(int keyIndex)
{
	IBezPoint3Key pivotKey,auxPivotKey,prevPivotKey,offsetKey;
	pivotKeys->GetKey(keyIndex,&pivotKey);
	if (keyIndex>0)
	{
		pivotKeys->GetKey((keyIndex-1),&auxPivotKey);
		if (pivotKey.val==auxPivotKey.val)
		{
			prevPivotKeys->GetKey(keyIndex-1,&prevPivotKey);
			prevPivotKey.time=pivotKey.time;
			prevPivotKeys->SetKey(keyIndex,&prevPivotKey);
			offsetKeys->GetKey(keyIndex-1,&offsetKey);
			offsetKey.time=pivotKey.time;
			offsetKeys->SetKey(keyIndex,&offsetKey);
			return TRUE;
		}
	}
	if (keyIndex<(pivotKeys->GetNumKeys()-1))
	{
		pivotKeys->GetKey((keyIndex+1),&auxPivotKey);
		if (pivotKey.val==auxPivotKey.val)
		{
			prevPivotKeys->GetKey(keyIndex+1,&prevPivotKey);
			prevPivotKey.time=pivotKey.time;
			prevPivotKeys->SetKey(keyIndex,&prevPivotKey);
			offsetKeys->GetKey(keyIndex+1,&offsetKey);
			offsetKey.time=pivotKey.time;
			offsetKeys->SetKey(keyIndex,&offsetKey);
			return TRUE;
		}
	}
	return FALSE;
}
//this function is used to check if any pair of keys has been swaped, for example when the user slides one keyframe
//over another
BOOL AnimPivot::SwapOffset(int keyIndex)
{
	if (keyIndex<(pivotKeys->GetNumKeys()-1))
	{
		if (KeysEqual(keyIndex,keyIndex+1))
		{
			IBezPoint3Key pivotKey,prevPivotKey,offsetKey;
			prevPivotKeys->GetKey(keyIndex,&prevPivotKey);
			offsetKeys->GetKey(keyIndex,&offsetKey);
			pivotKeys->GetKey(keyIndex+1,&pivotKey);
			prevPivotKey.time=pivotKey.time;
			offsetKey.time=pivotKey.time;
			prevPivotKeys->SetKey(keyIndex,&prevPivotKey);
			offsetKeys->SetKey(keyIndex,&offsetKey);
			prevPivotKeys->SortKeys();
			offsetKeys->SortKeys();
			return TRUE;
		}
		if (KeysEqual(keyIndex+1,keyIndex))
		{
			IBezPoint3Key pivotKey,prevPivotKey,offsetKey;
			prevPivotKeys->GetKey(keyIndex+1,&prevPivotKey);
			offsetKeys->GetKey(keyIndex+1,&offsetKey);
			pivotKeys->GetKey(keyIndex,&pivotKey);
			prevPivotKey.time=pivotKey.time;
			offsetKey.time=pivotKey.time;
			prevPivotKeys->SetKey(keyIndex+1,&prevPivotKey);
			offsetKeys->SetKey(keyIndex+1,&offsetKey);
			prevPivotKeys->SortKeys();
			offsetKeys->SortKeys();
			return TRUE;
		}
	}
	return FALSE;
}
BOOL AnimPivot::KeysEqual(int pivotKeyIndex,int prevPivotKeyIndex)
{
	IBezPoint3Key pivotKey,prevPivotKey;
	pivotKeys->GetKey(pivotKeyIndex,&pivotKey);
	prevPivotKeys->GetKey(prevPivotKeyIndex,&prevPivotKey);
	//tangents are not used in comparations, because some length values issues (a pivot can change its outlength value without notification)
	if (pivotKey.val==prevPivotKey.val && pivotKey.time==prevPivotKey.time /*&& pivotKey.outtan==prevPivotKey.outtan && pivotKey.outLength==prevPivotKey.outLength && pivotKey.intan==prevPivotKey.intan && pivotKey.inLength==prevPivotKey.inLength*/)
		return TRUE;
	else
		return FALSE;
}
void AnimPivot::SetStepKey(int keyIndex)
{
	BOOL stepKey;
	stepPblock->GetValue(pb_stepKeys,0,stepKey,FOREVER);
	if (stepKey)
	{
		IBezPoint3Key pivotKey;
		pivotKeys->GetKey(keyIndex,&pivotKey);
		SetInTanType(pivotKey.flags,BEZKEY_STEP);
		pivotKeys->SetKey(keyIndex,&pivotKey);
	}
}
void AnimPivot::ResetTM()
{
	SetXFormPacket mat;
	mat.tmAxis=value;
	mat.tmParent=parentTM;
	mat.command=XFORM_SET;
	TMCtrl->SetController((Control *)CreateInstance(CTRL_MATRIX3_CLASS_ID, Class_ID(PRS_CONTROL_CLASS_ID,0)));
	TMCtrl->GetController()->SetValue(0,&mat,1,CTRL_ABSOLUTE);
	InitOffset(Point3(0,0,0));
}
void AnimPivot::RemoveTarget()
{
	ReferenceMaker *theDep;
	DependentIterator di(TMCtrl);
	
	theDep=di.Next();
	while (theDep)
	{
		if (theDep->ClassID()==AnimPivotTarget_CLASS_ID)
			TMCtrl->GetController()/*->Clone()*/->TransferReferences((ReferenceTarget*)theDep);	
		theDep=di.Next();
	}		
}
Matrix3 AnimPivot::GetTargetTM(TimeValue t,Interval &valid)
{
	INode *theNode=pblock->GetINode(pb_target);
	return GetTargetTM(theNode,t,valid);
}

Matrix3 AnimPivot::GetTargetTM(INode *theNode,TimeValue t,Interval &valid)
{
	Matrix3 theTM;
	if (!theNode->GetParentNode()->IsRootNode())
		theTM=GetTargetTM(theNode->GetParentNode(),t,valid);
	else
		theTM=Matrix3(1);
	theNode->GetTMController()->GetValue(t,&theTM,valid,CTRL_RELATIVE);
	return theTM;
}
void AnimPivot::SOOffsetKey(int theKeyIndex)
{
	if (theKeyIndex>0 && theKeyIndex<(pivotKeys->GetNumKeys()-1))
	{
		IBezPoint3Key firstKey,nextKey,pivotKey,prevPivotKey;
		pivotKeys->GetKey(theKeyIndex-1,&firstKey);
		pivotKeys->GetKey(theKeyIndex+1,&nextKey);
		pivotKeys->GetKey(theKeyIndex,&pivotKey);
		if (GetOutTanType(firstKey.flags)==BEZKEY_STEP || GetInTanType(nextKey.flags)==BEZKEY_STEP)
		{
			//the pair of keyframes that the time is in does have step interpolation,
			//then an offset interp has to be calculated to avoid gaps
			float percent=FLOAT(pivotKey.time-firstKey.time)/FLOAT(nextKey.time-firstKey.time);
			if (percent<1.0f)
			{
				//The offset value equation goes as follows:
				//stepOffset=(O2-O1)*NoTrans(L2)+P2-P1
				//where:
				//		 L2 is the value of the TMCtrl in the next key time
				//		 P1 is the value of the first pivot key
				//		 P2 is the value of the next pivot key
				//		 O1 is the value of the first offset key
				//		 O2 is the value of the next offset key

				IBezPoint3Key firstOffsetKey,nextOffsetKey;
				Matrix3 TMNext=Matrix3(1);
				Point3 offsetVal;
				offsetKeys->GetKey(theKeyIndex-1,&firstOffsetKey);
				offsetKeys->GetKey(theKeyIndex+1,&nextOffsetKey);
				TMCtrl->GetController()->GetValue(nextKey.time,&TMNext,FOREVER,CTRL_RELATIVE);
				TMNext.NoTrans();
				offsetVal=(nextOffsetKey.val-firstOffsetKey.val)*TMNext+nextKey.val-firstKey.val;
				//next, a bezier interp has to be calculated with the stepOffset that was previously calculated 
				offsetVal=SOGetStepBezier(percent,offsetVal);

				pivotKey.val+=offsetVal;
				prevPivotKeys->SetKey(theKeyIndex,&pivotKey);
				pivotKeys->SetKey(theKeyIndex,&pivotKey);
			}
		}
	}
}
Point3 AnimPivot::SOGetStepBezier(float t,Point3 val)
{
	//get bezier interp, in this interp, the first point is zero, the first tangent and the second tangent
	//are zero, and the second point is the val.
	Point3 interpVal;
	interpVal.x=(3*val.x*pow(t,2)-2*val.x*pow(t,3));
	interpVal.y=(3*val.y*pow(t,2)-2*val.y*pow(t,3));
	interpVal.z=(3*val.z*pow(t,2)-2*val.z*pow(t,3));
	return interpVal;
}
Point3 AnimPivot::GetRelativePos()
{
	Point3 relPos;
	UpdateOffset();
	offsetCtrl->GetController()->GetValue(GetCOREInterface()->GetTime(),&relPos,FOREVER,CTRL_ABSOLUTE);
	return -relPos;
}
void AnimPivot::SetRelativePos(Point3 relPos)
{
	Point3 prevRelPos,transVector;
	Matrix3 TMVal=Matrix3(1);
	UpdateOffset();
	TimeValue currentTime=GetCOREInterface()->GetTime();
	offsetCtrl->GetController()->GetValue(currentTime,&prevRelPos,FOREVER,CTRL_ABSOLUTE);
	TMCtrl->GetController()->GetValue(currentTime,&TMVal,FOREVER,CTRL_RELATIVE);
	TMVal.NoTrans();
	transVector=(relPos+prevRelPos)*TMVal;
	pivotCtrl->GetController()->SetValue(currentTime,&transVector,1,CTRL_RELATIVE);
	//the offset should not be updated in set key mode, to avoid wrong offset transformations
	//unless a new key is created
	if (!GetSetKeyMode())
		UpdateOffset();
}
