//**************************************************************************/
// Copyright (c) 1998-2007 Autodesk, Inc.
// All rights reserved.
// 
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information written by Autodesk, Inc., and are
// protected by Federal copyright law. They may not be disclosed to third
// parties or copied or duplicated in any form, in whole or in part, without
// the prior written consent of Autodesk, Inc.
//**************************************************************************/
// DESCRIPTION: Appwizard generated plugin
// AUTHOR: Felix Joleanes
//***************************************************************************/

#include "AnimPivotTarget.h"
#include "ControlContainer.h"

static AnimPivotTargetClassDesc AnimPivotTargetDesc;
static AnimPivotTargetClassAccessor AnimPivotTargetAccessor;
ClassDesc2* GetAnimPivotTargetDesc() { return &AnimPivotTargetDesc; }

enum { 
	AnimPivotTarget_params,
	stepKeys_params
};
enum {
	pb_transPivot,
	pb_stepKeysV,
	pb_showPivot,
};
enum
{
	pb_stepKeys,
};

static ParamBlockDesc2 AnimPivotTarget_param_blk ( AnimPivotTarget_params, GetString(IDS_PARAMS),  0, &AnimPivotTargetDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL_TARGET, IDS_PARAMS, 0, 0, NULL,
	// params
	pb_transPivot,	"TransformPivot",	TYPE_BOOL,	0,	IDS_TRANSPIVOT,
		p_default,	TRUE,
		p_ui,		TYPE_SINGLECHEKBOX,		IDC_CHECK_TRANSPIVOT,
		end,
	pb_stepKeysV,	"",	TYPE_BOOL,	P_TRANSIENT,	IDS_STEPKEYS,
		p_ui,		TYPE_SINGLECHEKBOX,		IDC_CHECK_STEPKEYS,
		p_accessor,	&AnimPivotTargetAccessor,
		end,
	pb_showPivot,	"ShowPivot",	TYPE_BOOL,	0,	IDS_SHOWPIVOT,
		p_default,	TRUE,
		end,
	end
);
static ParamBlockDesc2 stepKeys_param_blk ( stepKeys_params, _T("step params"),  0, &AnimPivotTargetDesc, 
	P_AUTO_CONSTRUCT, STEP_PBLOCK_REF, 
	// params
	pb_stepKeys,	"StepKeys",	TYPE_BOOL,	0,	IDS_STEPKEYS,
		p_default,	FALSE,
		end,
	end
);

INT_PTR AnimPivotTargetDlgProc::DlgProc (TimeValue t, IParamMap2 *map, HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	ICustButton *iBut;
	BOOL showPivot,stepKeys;
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			animpivottarget->pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
			iBut = GetICustButton(GetDlgItem(animpivottarget->hwnd,IDC_BUTTON_PIVOT));
			iBut->SetType(CBT_CHECK);
			iBut->SetHighlightColor(GREEN_WASH);
			iBut->SetCheck(showPivot);
			ReleaseICustButton(iBut);
			iBut = GetICustButton(GetDlgItem(animpivottarget->hwnd,IDC_BUTTON_TRANSFORM));
			iBut->SetType(CBT_CHECK);
			iBut->SetHighlightColor(GREEN_WASH);
			iBut->SetCheck(!showPivot);
			ReleaseICustButton(iBut);
			animpivottarget->stepPblock->GetValue(pb_stepKeys,0,stepKeys,FOREVER);
			animpivottarget->pblock->SetValue(pb_stepKeysV,0,stepKeys);
		}
		break;
	case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDC_CHECK_STEPKEYS:
				animpivottarget->stepPblock->SetValue(pb_stepKeys,0,GetCheckBox(animpivottarget->hwnd,IDC_CHECK_STEPKEYS));
				break;
			case IDC_BUTTON_PIVOT:
				animpivottarget->pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
				if (!showPivot)
				{
					animpivottarget->pblock->SetValue(pb_showPivot,0,TRUE);
					iBut = GetICustButton(GetDlgItem(animpivottarget->hwnd,IDC_BUTTON_TRANSFORM));
					iBut->SetCheck(FALSE);
					ReleaseICustButton(iBut);
					animpivottarget->TMCtrl->EndEditParams(animpivottarget->ip,END_EDIT_REMOVEUI,NULL);
					animpivottarget->pivotCtrl->BeginEditParams(animpivottarget->ip,BEGIN_EDIT_MOTION,NULL);
				}
				iBut = GetICustButton(GetDlgItem(animpivottarget->hwnd,IDC_BUTTON_PIVOT));
				iBut->SetCheck(TRUE);
				ReleaseICustButton(iBut);
				break;
			case IDC_BUTTON_TRANSFORM:
				animpivottarget->pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
				if (showPivot)
				{
					animpivottarget->pblock->SetValue(pb_showPivot,0,FALSE);
					iBut = GetICustButton(GetDlgItem(animpivottarget->hwnd,IDC_BUTTON_PIVOT));
					iBut->SetCheck(FALSE);
					ReleaseICustButton(iBut);
					animpivottarget->pivotCtrl->EndEditParams(animpivottarget->ip,END_EDIT_REMOVEUI,NULL);
					animpivottarget->TMCtrl->BeginEditParams(animpivottarget->ip,BEGIN_EDIT_MOTION,NULL);
				}
				iBut = GetICustButton(GetDlgItem(animpivottarget->hwnd,IDC_BUTTON_TRANSFORM));
				iBut->SetCheck(TRUE);
				ReleaseICustButton(iBut);
				break;
			case IDC_BUTTON_ABOUT:
				DialogBox(
						hInstance,
						MAKEINTRESOURCE(IDD_DIALOG),
						hWnd,
						AboutDlgProc);
				break;
			}
		break;
	}
	return FALSE;
}
void AnimPivotTargetClassAccessor::Set(PB2Value& v,ReferenceMaker* owner,ParamID id,int tabIndex,TimeValue t)
{
	AnimPivotTarget *theAnimPivotTarget=(AnimPivotTarget *)owner;
	switch (id)
	{
		case pb_stepKeysV:
		{
			theAnimPivotTarget->stepPblock->SetValue(pb_stepKeys,0,v.i);
		}
	}
}
AnimPivotTarget::AnimPivotTarget(BOOL loading)
{
	pblock = NULL;
	stepPblock=NULL;
	pivotCtrl=NULL;
	TMCtrl=NULL;
	offsetCtrl=NULL;
	if (!loading)
	{
		// make the paramblock
		AnimPivotTargetDesc.MakeAutoParamBlocks(this);
		ReplaceReference(PIVOT_REF,new ControlContainer((Control *)CreateInstance(CTRL_POSITION_CLASS_ID, Class_ID(HYBRIDINTERP_POSITION_CLASS_ID,0)),GetString(IDS_PIVOT),FALSE));
		ReplaceReference(TM_REF,new ControlContainer(NewDefaultPositionController(),GetString(IDS_TM),FALSE));
		ReplaceReference(OFFSET_REF,new ControlContainer((Control *)CreateInstance(CTRL_POSITION_CLASS_ID, Class_ID(HYBRIDINTERP_POSITION_CLASS_ID,0)),GetString(IDS_PIVOT),FALSE));
	}
}
AnimPivotTarget::AnimPivotTarget(ControlContainer *newPivotCtrl,ControlContainer *newTMControl,IParamBlock2 *theStepPblock,ControlContainer *newOffsetCtrl)
{
	pblock = NULL;
	stepPblock=NULL;
	pivotCtrl=NULL;
	TMCtrl=NULL;
	offsetCtrl=NULL;
	// make the paramblock
	AnimPivotTargetDesc.MakeAutoParamBlocks(this);
	ReplaceReference(PIVOT_REF,newPivotCtrl);
	ReplaceReference(TM_REF,newTMControl);
	ReplaceReference(STEP_PBLOCK_REF,theStepPblock);
	ReplaceReference(OFFSET_REF,newOffsetCtrl);
}

Animatable* AnimPivotTarget::SubAnim(int i)
{
	switch (i)
	{
	case PIVOT_REF:
		return pivotCtrl;
		break;
	case TM_REF:
		return TMCtrl;
		break;
	}
	return NULL;

}
TSTR AnimPivotTarget::SubAnimName(int i)
{
	switch(i)
	{
	case PIVOT_REF:
		return GetString(IDS_PIVOT);
		break;
	case TM_REF:
		return GetString(IDS_TM);
		break;
	default:
		return _T("");
		break;
	}
}
void AnimPivotTarget::MouseCycleStarted(TimeValue t)
{
	NotifyDependents(FOREVER,0,REFMSG_PIVOT_MOUSE_CYCLE_STARTED);
}
void AnimPivotTarget::MouseCycleCompleted(TimeValue t)
{
	NotifyDependents(FOREVER,0,REFMSG_PIVOT_MOUSE_CYCLE_COMPLETED);
}
void AnimPivotTarget::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	if (flags & BEGIN_EDIT_MOTION)
	{
		this->ip=ip;
		AnimPivotTargetDesc.BeginEditParams(ip,this,flags,prev);
		hwnd=pblock->GetMap()->GetHWnd();
		BOOL showPivot;
		pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
		if (showPivot)
			pivotCtrl->BeginEditParams(ip,flags,prev);
		else
			TMCtrl->BeginEditParams(ip,flags,prev);
		
		AnimPivotTarget_param_blk.SetUserDlgProc(AnimPivotTarget_params,new AnimPivotTargetDlgProc(this));
	}
}
void AnimPivotTarget::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	if (flags & END_EDIT_REMOVEUI)
	{
		AnimPivotTargetDesc.EndEditParams(ip,this,flags,next);
		BOOL showPivot;
		pblock->GetValue(pb_showPivot,0,showPivot,FOREVER);
		if (showPivot)
			pivotCtrl->EndEditParams(ip,flags,next);
		else
			TMCtrl->EndEditParams(ip,flags,next);
	}
}


RefTargetHandle AnimPivotTarget::GetReference(int i)
{ 
	switch (i)
	{
	case PIVOT_REF:
		return pivotCtrl;
		break;
	case TM_REF:
		return TMCtrl;
		break;
	case PBLOCK_REF:
		return pblock;
		break;
	case STEP_PBLOCK_REF:
		return stepPblock;
		break;
	case OFFSET_REF:
		return offsetCtrl;
		break;
	}
	return NULL;
}
void AnimPivotTarget::SetReference(int i, RefTargetHandle rtarg) 
{ 
	switch (i)
	{
	case PIVOT_REF:
		pivotCtrl=(ControlContainer *)rtarg;
		if (pivotCtrl)
			pivotKeys=GetKeyControlInterface(pivotCtrl->GetController());
		break;
	case TM_REF:
		TMCtrl=(ControlContainer*)rtarg;
		break;
	case PBLOCK_REF:
		pblock=(IParamBlock2*)rtarg;
		break;
	case STEP_PBLOCK_REF:
		stepPblock=(IParamBlock2*)rtarg;
		break;
	case OFFSET_REF:
		offsetCtrl=(ControlContainer*)rtarg;
		if(offsetCtrl)
			offsetKeys=GetKeyControlInterface(offsetCtrl->GetController());
		break;
	}
}

#if IS_SUPMAX2015
RefResult AnimPivotTarget::NotifyRefChanged(const Interval& changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message, BOOL propagate)
#else
RefResult AnimPivotTarget::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message)
#endif
{ 

switch (message) { 
	 case REFMSG_CHANGE: 
		 if (hTarget==pivotCtrl || hTarget==TMCtrl)
			NotifyDependents(FOREVER,0,REFMSG_IGNORE_CHANGE);
		 if (hTarget==offsetCtrl)
			 return REF_STOP;
	 break; 
	 case REFMSG_OBJECT_CACHE_DUMPED: 
		 return REF_STOP; 
	 break; 
 } 
return REF_SUCCEED; 
}



void AnimPivotTarget::Copy(Control *from)
{
	if (from->ClassID()==Class_ID(PRS_CONTROL_CLASS_ID,0))
		TMCtrl->SetController((Control*)from);	
	else
	{
		Matrix3 TMVal=Matrix3(1);
		from->GetValue(GetCOREInterface()->GetTime(),&TMVal,FOREVER,CTRL_RELATIVE);
		from=(Control *)CreateInstance(CTRL_MATRIX3_CLASS_ID, Class_ID(PRS_CONTROL_CLASS_ID,0));
		SetXFormPacket mat;
		mat.command=XFORM_SET;
		mat.tmAxis=TMVal;
		mat.tmParent=Matrix3(1);		
		from->SetValue(0,&mat,1,CTRL_ABSOLUTE);
	}
	NotifyDependents(FOREVER,0,REFMSG_CHANGE);
	NotifyDependents(FOREVER,0,REFMSG_SUBANIM_STRUCTURE_CHANGED);
}
RefTargetHandle AnimPivotTarget::Clone(RemapDir& remap)
{
	Control *p=(Control*)TMCtrl->GetController()->Clone(remap);
	BaseClone(this, p, remap);
	return p;
}
void AnimPivotTarget::GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method)
{
	pivotCtrl->GetController()->GetValue(t,val,valid,CTRL_RELATIVE);
	SOGetValue(t,val,CTRL_RELATIVE);
	TMCtrl->GetController()->GetValue(t,val,valid,CTRL_RELATIVE);
}
void AnimPivotTarget::SetValue(TimeValue t, void *val, int commit, GetSetMethod method)
{
	BOOL transPivot;
	pblock->GetValue(pb_transPivot,0,transPivot,FOREVER);
	SetXFormPacket *mat=(SetXFormPacket *)val;
	SetXFormPacket newMat;
	Matrix3 setTM;
	Point3 pivotVal;
	if (transPivot)
	{
		switch(mat->command)
		{
		case XFORM_MOVE:
			mat->tmAxis.NoTrans();
			mat->tmParent.NoTrans();
			pivotVal=mat->p*mat->tmAxis*Inverse(mat->tmParent);
			pivotCtrl->GetController()->SetValue(t,&pivotVal,commit,method);
			break;
		case XFORM_SET:
			setTM=Matrix3(1);
			TMCtrl->GetController()->GetValue(t,&setTM,FOREVER,CTRL_RELATIVE);
			pivotVal=(Inverse(setTM)*mat->tmAxis*Inverse(mat->tmParent)).GetTrans();
			pivotCtrl->GetController()->SetValue(t,&pivotVal,1,CTRL_ABSOLUTE);
			NotifyDependents(FOREVER,0,REFMSG_PIVOT_MOUSE_CYCLE_COMPLETED);
			newMat=*mat;
			newMat.tmParent.PreTranslate(pivotVal);
			TMCtrl->GetController()->SetValue(t,&newMat,1,CTRL_ABSOLUTE);
			break;
		default:
			TMCtrl->GetController()->SetValue(t,val,commit,method);
			break;
		}
	}
	else
	{
		pivotCtrl->GetController()->GetValue(t,&pivotVal,FOREVER,CTRL_ABSOLUTE);
		newMat=*mat;
		newMat.tmParent.PreTranslate(pivotVal);
		TMCtrl->GetController()->SetValue(t,&newMat,commit,method);
	}
}
void AnimPivotTarget::CommitValue(TimeValue t)
{
	pivotCtrl->GetController()->CommitValue(t);
	TMCtrl->GetController()->CommitValue(t);
}

void AnimPivotTarget::RestoreValue(TimeValue t)
{
	pivotCtrl->GetController()->RestoreValue(t);
	TMCtrl->GetController()->RestoreValue(t);
}
Control* AnimPivotTarget::GetPositionController()
{
	BOOL transPivot;
	pblock->GetValue(pb_transPivot,0,transPivot,FOREVER);
	
	if (TMCtrl->GetController()) 
	{
		if (transPivot)
			return pivotCtrl->GetController();
		else
			return TMCtrl->GetController()->GetPositionController(); 
	}
	else return NULL;
}
Control* AnimPivotTarget::GetRotationController()
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->GetRotationController(); 
	else 
		return NULL;
}
Control* AnimPivotTarget::GetScaleController()
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->GetScaleController(); 
	else 
		return NULL;
}
BOOL AnimPivotTarget::SetPositionController(Control *c)
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->SetPositionController(c);
	else 
		return FALSE;
}
BOOL AnimPivotTarget::SetRotationController(Control *c)
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->SetRotationController(c); 
	else 
		return FALSE;
}
BOOL AnimPivotTarget::SetScaleController(Control *c)
{
	if (TMCtrl->GetController()) 
		return TMCtrl->GetController()->SetScaleController(c);
	else
		return FALSE;
}
BOOL AnimPivotTarget::ChangeParents  (TimeValue  t,const Matrix3 &oldP, const Matrix3 &newP, const Matrix3 &tm)
{
	if (TMCtrl->GetController())
	{
		SetXFormPacket mat;
		mat.tmParent=newP;
		mat.tmAxis=tm;
		mat.command=XFORM_SET;
		TMCtrl->GetController()->SetValue(t,&mat);
	}
	return TRUE;
}
void AnimPivotTarget::SOGetValue(TimeValue t, void *val, GetSetMethod method)
{
	int firstKeyIndex=pivotCtrl->GetController()->NumKeys()-1;
	int nextKeyIndex,firstOffsetKeyIndex,nextOffsetKeyIndex;
	BOOL notFound=TRUE;
	Point3 stepVal,offsetVal;
	TimeValue keyTime;
	while (notFound && firstKeyIndex>=0)
	{
		keyTime=pivotCtrl->GetController()->GetKeyTime(firstKeyIndex);
		if (t>=keyTime)
		{
			firstOffsetKeyIndex=offsetCtrl->GetController()->GetKeyIndex(keyTime);
			if (firstOffsetKeyIndex>=0)
				notFound=FALSE;
			else
				firstKeyIndex--;
		}
		else
			firstKeyIndex--;
	}
	if (notFound)
	{
		//if the time is not within any pair of keyframes, then, there is no offset
		stepVal=Point3(0.0f,0.0f,0.0f);
	}
	else
	{
		nextKeyIndex=firstKeyIndex+1;
		notFound=TRUE;
		while (notFound && nextKeyIndex<pivotCtrl->GetController()->NumKeys())
		{
			keyTime=pivotCtrl->GetController()->GetKeyTime(nextKeyIndex);
			nextOffsetKeyIndex=offsetCtrl->GetController()->GetKeyIndex(keyTime);
			if (nextOffsetKeyIndex>0)
				notFound=FALSE;
			else
				nextKeyIndex++;
		}
		if (notFound)
		{
			//if there isn't next key, there is not offset
			stepVal=Point3(0.0f,0.0f,0.0f);
		}
		else
		{
			IBezPoint3Key firstKey,nextKey;
			pivotKeys->GetKey(firstKeyIndex,&firstKey);
			pivotKeys->GetKey(nextKeyIndex,&nextKey);
			if (GetOutTanType(firstKey.flags)==BEZKEY_STEP || GetInTanType(nextKey.flags)==BEZKEY_STEP)
			{
				//the pair of keyframes that the time is in does have step interpolation,
				//then an offset interp has to be calculated to avoid gaps
				float percent=FLOAT(t-firstKey.time)/FLOAT(nextKey.time-firstKey.time);
				//The offset value equation goes as follows:
				//stepOffset=(O2-O1)*NoTrans(L2)+P2-P1
				//where:
				//		 L2 is the value of the TMCtrl in the next key time
				//		 P1 is the value of the first pivot key
				//		 P2 is the value of the next pivot key
				//		 O1 is the value of the first offset key
				//		 O2 is the value of the next offset key

				IBezPoint3Key firstOffsetKey,nextOffsetKey;
				Matrix3 TMNext=Matrix3(1);
				offsetKeys->GetKey(firstOffsetKeyIndex,&firstOffsetKey);
				offsetKeys->GetKey(nextOffsetKeyIndex,&nextOffsetKey);
				TMCtrl->GetController()->GetValue(nextKey.time,&TMNext,FOREVER,CTRL_RELATIVE);
				TMNext.NoTrans();
				offsetVal=(nextOffsetKey.val-firstOffsetKey.val)*TMNext+nextKey.val-firstKey.val;
				//next, a bezier interp has to be calculated with the Poffset that was previously calculated 
				stepVal=SOGetStepBezier(percent,offsetVal);
			}
			else
			{
				//the pair of keyframes that the time is in doesn't have step interpolation,
				//then, there is no offset
				stepVal=Point3(0.0f,0.0f,0.0f);
			}
		}
	}
	if (method==CTRL_ABSOLUTE)
		*((Point3 *)val)=stepVal;
	else
		((Matrix3*)val)->PreTranslate(stepVal);
}
Point3 AnimPivotTarget::SOGetStepBezier(float t,Point3 val)
{
	//get bezier interp, in this interp, the first point is zero, the first tangent and the second tangent
	//are zero, and the second point is the val.
	Point3 interpVal;
	interpVal.x=(3*val.x*pow(t,2)-2*val.x*pow(t,3));
	interpVal.y=(3*val.y*pow(t,2)-2*val.y*pow(t,3));
	interpVal.z=(3*val.z*pow(t,2)-2*val.z*pow(t,3));
	return interpVal;
}