#pragma once

//**************************************************************************/
// Copyright (c) 1998-2007 Autodesk, Inc.
// All rights reserved.
// 
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information written by Autodesk, Inc., and are
// protected by Federal copyright law. They may not be disclosed to third
// parties or copied or duplicated in any form, in whole or in part, without
// the prior written consent of Autodesk, Inc.
//**************************************************************************/
// DESCRIPTION: Includes for Plugins
// AUTHOR: Felix Joleanes
//***************************************************************************/

#include "3dsmaxsdk_preinclude.h"
#include "Max.h"
#include "resource.h"
#include "istdplug.h"
#include "iparamb2.h"
#include "iparamm2.h"

#define IS_SUPMAX2010 (MAX_RELEASE>=12000)
#define IS_SUPMAX2012 (MAX_RELEASE>=14000)
#define IS_SUPMAX2013 (MAX_RELEASE>=15000)
#define IS_SUPMAX2015 (MAX_RELEASE>=17000)

#if IS_SUPMAX2012
	#include "maxscript\maxscript.h"
#else
	#include "maxscrpt\maxscrpt.h"
#endif

#if IS_SUPMAX2013
	#define end p_end	
#endif


extern TCHAR *GetString(int id);

extern HINSTANCE hInstance;

#define AnimPivot_CLASS_ID			Class_ID(0x3d1aff84, 0x11124a76)
#define AnimPivotTarget_CLASS_ID	Class_ID(0x3d1aff85, 0x11124a77)		

#define PIVOT_REF 0
#define TM_REF 1
#define PBLOCK_REF	2
#define STEP_PBLOCK_REF 3
#define OFFSET_REF 4
#define PREVPIVOT_REF 5
#define NSUBS 2
#define NPBLOCKS 1
#define NREFS 6
#define NTARGETREFS 5

#define REFMSG_IGNORE_CHANGE					0x00000476
#define REFMSG_PIVOT_MOUSE_CYCLE_STARTED		0x00000477
#define REFMSG_PIVOT_MOUSE_CYCLE_COMPLETED		0x00000478

static INT_PTR CALLBACK AboutDlgProc(
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
switch (msg) {
	case WM_INITDIALOG:
		CenterWindow(hWnd, GetParent(hWnd));
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			case IDOK:
				EndDialog(hWnd,1);
				break;
			}
		break;
	case WM_CLOSE:
			EndDialog(hWnd,1);		
		break;
	
	default:
		return FALSE;
	}
return TRUE;
}