//**************************************************************************/
// Copyright (c) 1998-2007 Autodesk, Inc.
// All rights reserved.
// 
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information written by Autodesk, Inc., and are
// protected by Federal copyright law. They may not be disclosed to third
// parties or copied or duplicated in any form, in whole or in part, without
// the prior written consent of Autodesk, Inc.
//**************************************************************************/
// DESCRIPTION: Appwizard generated plugin
// AUTHOR: Felix Joleanes
//***************************************************************************/

#include "ControlContainer.h"


static ControlContainerClassDesc ControlContainerDesc;
ClassDesc2* GetControlContainerDesc() { return &ControlContainerDesc; }

enum { 
	ControlContainer_params,
};
enum {
	pb_canAssignController,
	pb_subAnimName,
};

static ParamBlockDesc2 ControlContainer_param_blk ( ControlContainer_params, _T("params"),  0, &ControlContainerDesc, 
	P_AUTO_CONSTRUCT, 0,
	// params
	pb_canAssignController,		_T(""),		TYPE_BOOL,	0,	IDS_CANASSIGNCONTROLLER,
		p_default,				TRUE,
		end,
	pb_subAnimName,		_T(""),		TYPE_STRING,	0,	IDS_SUBANIMNAME,
		end,
	end
);

ControlContainer::ControlContainer()
{
	pblock=NULL;
	theControl=NULL;
	ControlContainerDesc.MakeAutoParamBlocks(this);
}
ControlContainer::ControlContainer(Control *newControl,MCHAR* subAnimName,BOOL canAssignController)
{
	pblock=NULL;
	theControl=NULL;
	ControlContainerDesc.MakeAutoParamBlocks(this);
	ReplaceReference(1,newControl);
	pblock->SetValue(pb_subAnimName,0,subAnimName);
	pblock->SetValue(pb_canAssignController,0,canAssignController);
}
Animatable* ControlContainer::SubAnim(int i)
{
	return theControl;
}
TSTR ControlContainer::SubAnimName(int i)
{
#if IS_SUPMAX2010
	const MCHAR* subAnimName;
#else
	MCHAR* subAnimName;
#endif
	pblock->GetValue(pb_subAnimName,0,subAnimName,FOREVER);
	return subAnimName;
}
int ControlContainer::SubNumToRefNum(int subNum)
{ 
	BOOL canAssignController;
	pblock->GetValue(pb_canAssignController,0,canAssignController,FOREVER);
	if (canAssignController)
		return 1;
	else
		return -1;
}
BOOL ControlContainer::AssignController(Animatable *control,int subAnim)
{
	ReplaceReference(1,(Control*)control);
	return TRUE;
}
BOOL ControlContainer::CanAssignController(int subAnim)
{
	BOOL canAssignController;
	pblock->GetValue(pb_canAssignController,0,canAssignController,FOREVER);
	return canAssignController;
}
void ControlContainer::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	theControl->BeginEditParams(ip,flags,prev);
}
void ControlContainer::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next )
{
	theControl->EndEditParams(ip,flags,next);
}
RefTargetHandle ControlContainer::GetReference(int i)
{
	if (i==0)
		return pblock;
	else
		return theControl;
}
void ControlContainer::SetReference(int i, RefTargetHandle rtarg)
{
	if (i==0)
		pblock=(IParamBlock2*)rtarg;
	else
	{
		theControl=(Control*)rtarg;
	}
}

#if IS_SUPMAX2015
RefResult ControlContainer::NotifyRefChanged(const Interval& changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message, BOOL propagate)
#else
RefResult ControlContainer::NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message)
#endif
{
	if (hTarget==theControl)
		return REF_SUCCEED;
	else
		return REF_STOP;
}
RefTargetHandle ControlContainer::Clone( RemapDir &remap )
{
	ControlContainer *p = new ControlContainer();
	p->ReplaceReference(0,remap.CloneRef(pblock));
	p->ReplaceReference(1,remap.CloneRef(theControl));
	BaseClone(this, p, remap);
	return p;
}
void ControlContainer::GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method)
{
	theControl->GetValue(t,val,valid,method);
}
void ControlContainer::SetValue(TimeValue t, void *val, int commit, GetSetMethod method)
{
	theControl->SetValue(t,val,commit,method);
}
void ControlContainer::CommitValue(TimeValue t)
{
	theControl->CommitValue(t);
}
void ControlContainer::RestoreValue(TimeValue t)
{
	theControl->RestoreValue(t);
}
void ControlContainer::SetController(Control *newControl)
{
	ReplaceReference(1,newControl);
}
void ControlContainer::SetSubAnimName(MCHAR* subAnimName)
{
	pblock->SetValue(pb_subAnimName,0,subAnimName);
}
Control* ControlContainer::GetController()
{
	return theControl;
}
MCHAR* ControlContainer::GetSubAnimName()
{
#if IS_SUPMAX2010
	const MCHAR* subAnimName;
#else
	MCHAR* subAnimName;
#endif
	pblock->GetValue(pb_subAnimName,0,subAnimName,FOREVER);
	return (MCHAR*)subAnimName;
}