#pragma once

//**************************************************************************/
// Copyright (c) 1998-2007 Autodesk, Inc.
// All rights reserved.
// 
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information written by Autodesk, Inc., and are
// protected by Federal copyright law. They may not be disclosed to third
// parties or copied or duplicated in any form, in whole or in part, without
// the prior written consent of Autodesk, Inc.
//**************************************************************************/
// DESCRIPTION: Includes for Plugins
// AUTHOR: 
//***************************************************************************/

#include "AnimatablePivot.h"
//SIMPLE TYPE



extern TCHAR *GetString(int id);

extern HINSTANCE hInstance;

#define ControlContainer_CLASS_ID	Class_ID(0x784322f5, 0x5698e777)


class ControlContainer : public ReferenceTarget
{
public:
	void DeleteThis() { delete this; }
	Control *theControl;
	IParamBlock2 *pblock;
	ControlContainer();
	ControlContainer(Control *newControl,MCHAR* subAnimName,BOOL canAssignController);
	~ControlContainer(){}
	BOOL BypassTreeView() {return TRUE;}
	Class_ID ClassID() {return ControlContainer_CLASS_ID;}		
	SClass_ID SuperClassID() { return REF_TARGET_CLASS_ID; }
	void GetClassName(TSTR& s) {s = GetString(IDS_CONTAINER_CLASS_NAME);}
	int NumSubs() { return 1;}
	Animatable* SubAnim(int i);
	TSTR SubAnimName(int i);
	int SubNumToRefNum(int subNum);
	BOOL AssignController(Animatable *control,int subAnim); 
	BOOL CanAssignController(int subAnim);
	void BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev ); 
	void EndEditParams( IObjParam *ip, ULONG flags,Animatable *next ); 
	int NumRefs() {return 2;}
	RefTargetHandle GetReference(int i);
	void SetReference(int i, RefTargetHandle rtarg);

#if IS_SUPMAX2015
		RefResult NotifyRefChanged(const Interval& changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message, BOOL propagate);
#else
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message);
#endif

	RefTargetHandle Clone( RemapDir &remap );
	void GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method = CTRL_ABSOLUTE );
	void SetValue(TimeValue t, void *val, int commit=1, GetSetMethod method= CTRL_ABSOLUTE);
	void CommitValue(TimeValue t);
	void RestoreValue(TimeValue t);
	void SetController(Control *newControl);
	void SetSubAnimName(MCHAR* SubAnimName);
	Control *GetController();
	MCHAR *GetSubAnimName();

};
class ControlContainerClassDesc : public ClassDesc2 
{
public:
	virtual int IsPublic() 							{ return FALSE; }
	virtual void* Create(BOOL loading) 		{return new ControlContainer(); }
	void DeleteThis() { delete this; }
	virtual const TCHAR *	ClassName() 			{ return GetString(IDS_CONTAINER_CLASS_NAME); }
	virtual SClass_ID SuperClassID() 				{ return REF_TARGET_CLASS_ID; }
	virtual Class_ID ClassID() 						{ return ControlContainer_CLASS_ID; }
	virtual const TCHAR* Category() 				{ return _T(""); }

	virtual const TCHAR* InternalName() 			{ return _T("ControlContainer"); }	// returns fixed parsable name (scripter-visible name)
	virtual HINSTANCE HInstance() 					{ return hInstance; }					// returns owning module handle
};

